Public Class fmMain
    Private WithEvents wclWiFiDirectAdvertiser As wclWiFiDirectAdvertiser

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbDiscoverability.SelectedIndex = 2
        cbPairingProcedure.SelectedIndex = 1

        wclWiFiDirectAdvertiser = New wclWiFiDirectAdvertiser()
    End Sub

    Private Sub fmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        wclWiFiDirectAdvertiser.Stop()
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnAcceptDevice(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByRef Accept As Boolean) Handles wclWiFiDirectAdvertiser.OnAcceptDevice
        lbLog.Items.Add("Accepting device " + Device.Id)
            Accept = MessageBox.Show("Accept connection from " + Device.Name + "?", "Connection", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes
        If Accept Then
            Dim Item As ListViewItem = lvDevices.Items.Add(Device.Name)
            Item.SubItems.Add(Device.Id)
            Item.SubItems.Add("Connecting")
        End If
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnDeviceConnected(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByVal [Error] As Integer) Handles wclWiFiDirectAdvertiser.OnDeviceConnected
        Dim Item As ListViewItem = GetItem(Device.Id)
        If Item IsNot Nothing Then
            If [Error] = wclErrors.WCL_E_SUCCESS Then
                Item.SubItems(2).Text = "Connected"

                lbLog.Items.Add(Device.Name + " connected")
                lbLog.Items.Add("  Local IP: " + Device.LocalAddress)
                lbLog.Items.Add("  Remote IP: " + Device.RemoteAddress)
            Else
                lbLog.Items.Add(Device.Name + " connect error: 0x" + [Error].ToString("X8"))
                lvDevices.Items.Remove(Item)
            End If
        End If
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnDeviceDisconnected(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByVal Reason As Integer) Handles wclWiFiDirectAdvertiser.OnDeviceDisconnected
        Dim Item As ListViewItem = GetItem(Device.Id)
        If Item IsNot Nothing Then
            lbLog.Items.Add(Device.Name + " disconnected. Reason: 0x" + Reason.ToString("X8"))
            lvDevices.Items.Remove(Item)
        End If
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnPairCompleted(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByVal Result As Integer) Handles wclWiFiDirectAdvertiser.OnPairCompleted
        lbLog.Items.Add(Device.Name + " paired. Result: 0x" + Result.ToString("X8"))
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnPairConfirm(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByRef Confirm As Boolean) Handles wclWiFiDirectAdvertiser.OnPairConfirm
        Confirm = MessageBox.Show("Confirm " + Device.Name + " connection", "Pairing", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnPairDisplayPin(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByVal Pin As String) Handles wclWiFiDirectAdvertiser.OnPairDisplayPin
        MessageBox.Show("Use " + Pin + " PIN to pair with " + Device.Name)
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnPairGetParams(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByRef GroupOwnerIntent As Short, ByRef ConfigurationMethods As wclWiFi.wclWiFiDirectConfigurationMethod, ByRef PairingProcedure As wclWiFi.wclWiFiDirectPairingProcedure) Handles wclWiFiDirectAdvertiser.OnPairGetParams
        lbLog.Items.Add(Device.Name + " quering pairing params")

        Select Case cbPairingProcedure.SelectedIndex
            Case 0
                PairingProcedure = wclWiFiDirectPairingProcedure.ppInvitation
            Case 1
                PairingProcedure = wclWiFiDirectPairingProcedure.ppGroupOwnerNegotiation
            Case Else
                PairingProcedure = wclWiFiDirectPairingProcedure.ppGroupOwnerNegotiation
        End Select
        GroupOwnerIntent = Convert.ToInt16(edGroupOwnerIntent.Text)
        ConfigurationMethods = 0
        If cbDisplayPIN.Checked Then
            ConfigurationMethods = ConfigurationMethods Or wclWiFiDirectConfigurationMethod.cmDisplayPin
        End If
        If cbProvidePIN.Checked Then
            ConfigurationMethods = ConfigurationMethods Or wclWiFiDirectConfigurationMethod.cmProvidePin
        End If
        If cbPushButton.Checked Then
            ConfigurationMethods = ConfigurationMethods Or wclWiFiDirectConfigurationMethod.cmPushButton
        End If
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnPairProvidePin(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByRef Pin As String) Handles wclWiFiDirectAdvertiser.OnPairProvidePin
        Pin = Microsoft.VisualBasic.Interaction.InputBox("Enter PIN for ", "Pairing", "", Left, Top)
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnStarted(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclWiFiDirectAdvertiser.OnStarted
        lbLog.Items.Add("Advertiser has been started")
    End Sub

    Private Sub wclWiFiDirectAdvertiser_OnStopped(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclWiFiDirectAdvertiser.OnStopped
        lvDevices.Items.Clear()

        lbLog.Items.Add("Advertiser has been stopped")
    End Sub

    Private Sub btClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClear.Click
        lbLog.Items.Clear()
    End Sub

    Private Sub btDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDisconnect.Click
        If lvDevices.SelectedItems.Count = 0 Then
            MessageBox.Show("Select device")
        Else
            For i As Integer = 0 To wclWiFiDirectAdvertiser.Count - 1
                If wclWiFiDirectAdvertiser(i).Id = lvDevices.SelectedItems(0).SubItems(1).Text Then
                    Dim Res As Int32 = wclWiFiDirectAdvertiser(i).Disconnect()
                    If Res <> wclErrors.WCL_E_SUCCESS Then
                        MessageBox.Show("Disconnect error: 0x" + Res.ToString("X8"))
                        Exit For
                    End If
                End If
            Next i
        End If
    End Sub

    Private Sub btStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStop.Click
        Dim Res As Int32 = wclWiFiDirectAdvertiser.Stop()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Stop error: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStart.Click
        If wclWiFiDirectAdvertiser.Active Then
            MessageBox.Show("Already running")
        Else
            Select Case cbDiscoverability.SelectedIndex
                Case 0
                    wclWiFiDirectAdvertiser.Discoverability = wclWiFiDirectAdvertisementDiscoverability.adIntensive
                Case 1
                    wclWiFiDirectAdvertiser.Discoverability = wclWiFiDirectAdvertisementDiscoverability.adNone
                Case 2
                    wclWiFiDirectAdvertiser.Discoverability = wclWiFiDirectAdvertisementDiscoverability.adNormal
            End Select
            wclWiFiDirectAdvertiser.AutonomousGroupOwnerEnabled = cbAutonomousGroupOwner.Checked

            Dim Res As Int32 = wclWiFiDirectAdvertiser.Start()
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Start error: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Function GetItem(ByVal Id As String) As ListViewItem
        For Each Item As ListViewItem In lvDevices.Items
            If Item.SubItems(1).Text = Id Then
                Return Item
            End If
        Next Item
        Return Nothing
    End Function
End Class
